select
    an.numero as numero
  , an.seriealfa as serie
  , cast(an.rgn as varchar(16)) as rgn
  , cast(an.regassocraca as varchar(16)) as rgd
  , (case when (an.sexo = 'M') then 1 else 2 end) as sexo
  , rac.codigoraca as raca
  , lpad(extract(day from an.dtnascimento),2,0) || '/' || lpad(extract(month from an.dtnascimento),2,0) || '/' || extract(year from an.dtnascimento) as dt_nasc
  , cast(mae.seriealfa as varchar(4)) as mae_ser
  --, cast(lpad(coalesce(mae.seriealfa, ''), 4, '') as varchar(4)) as mae_ser
  , (coalesce(mae.regassocraca, mae.rgn)) as mae
from
  associacao ass
  join animal an on 1 = 1
  left join graucruzamento gc on gc.cdgraucruzamento = an.cdgraucruzamento
  left join peso penasc on penasc.cdpeso =
    (select first 1 re.cdpeso from peso re where re.cdanimal = an.cdanimal and re.cdtipopeso in (1,2) and re.dtpeso = an.dtnascimento)
  left join animal pai on pai.cdanimal = an.cdpai
  left join graucruzamento gcpai on gcpai.cdgraucruzamento = pai.cdgraucruzamento
  left join animal mae on mae.cdanimal = an.cdmae
  join sp_retornaracaancp(an.cdanimal) rac on 1 = 1 and rac.codigoraca <> ''
  left join sp_retornaracaancp(pai.cdanimal) pairac on 1 = 1
  left join sp_retornaracaancp(mae.cdanimal) maerac on 1 = 1
  left join graucruzamento gcmae on gcmae.cdgraucruzamento = mae.cdgraucruzamento
  join reproducao par on par.cdreproducao = an.cdreproducao
  join reproducao cob on cob.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = par.cdanimal and re.cdtiporeproducao in (1,2,3) and
            re.data < par.data order by re.data desc)
  left join reproducao parant on parant.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = par.cdanimal and re.cdtiporeproducao = 7 and
            re.data < par.data order by re.data desc)
  join tipoparto tp on tp.cdtipoparto = par.cdtipoparto
  left join peso pe on pe.cdanimal = par.cdanimal and pe.dtpeso = par.data
  left join movgrupo m1 on m1.cdmovgrupo =
    (select first 1 re.cdmovgrupo from movgrupo re join movgrupoanimal rea on rea.cdmovgrupo = re.cdmovgrupo where
        rea.cdanimal = par.cdanimal and re.cdtipogrupoanimal = (select valor from configuracao where nome = 'TipoGrupoPrincipal')
            and re.dtmovimentacao <= par.data order by re.dtmovimentacao desc)
  left join grupoanimal g1 on g1.cdgrupoanimal = m1.cdgrupoanimal
  left join regimealimentar ra on ra.cdregimealimentar = g1.cdregimealimentar
  join setor se on se.cdsetor = an.cdsetor
where
  an.dtbaixa is null
  and an.tipoanimal = 'A'
  and an.animalrebanho = 1
  --Busca da nfa no cadastro da associacao
  and ass.numero = 100
  --Filtro de sexo
  and an.sexo in ('F','M')
  --Filtro de setor - NMERO - preencher com o numero do setor
  and se.numero in ('1', '2', '3', '4', '5')
  --Perodo de nascimento no formato AAA-MM-DD
  and an.dtnascimento between '2014-01-01' and '2014-08-14'
  -- Animais sem regime alimentar
  and g1.cdregimealimentar is null
